#include <iostream>
#include <vector>
#include <set>
using namespace std;
#define ll long long

vector<int> depth, pred;
vector<bool> used;
vector<vector<int>> v;

void dfs(int u) {
	used[u] = true;
	for (int i = 0; i < v[u].size(); i++) {
		if (!used[v[u][i]]) {
			depth[v[u][i]] = depth[u] + 1;
			dfs(v[u][i]);
		}
	}
}

int lca(int a, int b) {
	set<int> pr;
	while (a != 0) {
		pr.insert(a);
		a = pred[a];
	}
	while (b != 0) {
		if (pr.count(b))
			return b;
		b = pred[b];
	}
	return 0;
}

int main() {
	int n, m;
	cin >> n >> m;
	depth.assign(n, 0);
	pred.assign(n, -1);
	used.assign(n, false);
	v.assign(n, vector<int>());
	for (int i = 0; i < n - 1; i++) {
		int x;
		cin >> x;
		v[x - 1].push_back(i + 1);
		pred[i + 1] = x - 1;
	}
	dfs(0);
	int imax1 = 0, imax2 = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (lca(i, j) == 0 && depth[i] + depth[j] > depth[imax1] + depth[imax2]) {
				imax1 = i;
				imax2 = j;
			}
		}
	}
	if (depth[imax1] < depth[imax2])
		swap(imax1, imax2);
	if (m == 1)
		cout << depth[imax1] + depth[imax2];
	else
		cout << (depth[imax1] + 1) * (2 * m - 1) + depth[imax2];
	//system("pause");
	return 0;
}

/*
for (int i = 0; i < n; i++) {
cout << i << " : ";
for (int j = 0; j < v[i].size(); j++)
cout << v[i][j] << " ";
cout << endl;
}
*/